<?PHP
/************************************************************************/
/* AllMyLinks: Professional Link/Download Database                      */
/* ==================================================================== */
/*                                                                      */
/* Copyright (c) 2004 by voice of web                                   */
/*        http://www.php-resource.net                                   */
/* ==================================================================== */
/*                                                                      */
/* This file is part of the "AllMyPHP Project"!                         */
/* The "AllMyPHP Project" is part of voice of web.                      */
/* All rights reserved, see license for details!                        */
/*                                                                      */
/* ==================================================================== */
/*                                                                      */
/* Author: Voice of web <allmyphp@voice-of-web.de>                      */
/*                                                                      */
/* ==================================================================== */
/*                                                                      */
/* file          : ./include/allmyphp_functions.inc.php                 */
/* version       : 0.5.0                                                */
/* project       : AllMyLinks                                           */
/* last modified : Feb 20, 2004                                         */
/*                                                                      */
/************************************************************************/


// --> BEGIN FILE ACCESS SECURITY ----------------------------------------
if (eregi("allmyphp_functions.inc.php",$HTTP_SERVER_VARS['PHP_SELF'])) 
{
    die("YOU CAN NOT ACCESS THIS FILE DIRECTLY!");
}
// <-- END FILE ACCESS SECURITY ------------------------------------------

//+----------------------------------------------------------------------------------------+
//| function : AMP_format_link                                                    	   |
//| last modified: 29.06.2004                                                              |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  -- -+
//|                                                                                        |
//| this function replace GET link informations in readable format for search engines      |
//|                                                                                        |
//|----------------------------------------------------------------------------------------|
//| AMP_format_link (STRING url)                                                           |
//+----------------------------------------------------------------------------------------+
if(!function_exists('AMP_format_link'))
{
	function AMP_format_link($AMP_url)
	{
		$AMP_url = str_replace("?","/",$AMP_url);
		$AMP_url = str_replace("?","/",$AMP_url);
		return $AMP_url;
	}
}
//+----------------------------------------------------------------------------------------+
//| function : AMP_proof_field                                                    	   |
//| last modified: 23.02.2004                                                              |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  -- -+
//|                                                                                        |
//| global replacement function for all AllMyPHP field proof functions                     |
//| This function can proof AMP_field using proof-type AMP_prooftype                       |
//|                                                                                        |
//|                                                                                        |
//| PROOFTYPES:                                                                            |
//| email        = validate correct e-mail address (or not)                                |
//| url          = check string as url                                                     |
//| numeric      = check field numeric                                                     |
//| alphanumeric = field can be anything, but not empty                                    |
//|----------------------------------------------------------------------------------------|
//| AMP_proof_field (STRING field [, STRING prooftype])                                    |
//+----------------------------------------------------------------------------------------+
if(!function_exists('AMP_proof_field'))
{
	function AMP_proof_field($AMP_field, $AMP_prooftype)
	{
		switch($AMP_prooftype)
		{		
			case "email":
				if (!eregi("^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,4}$",$AMP_field)) 
				{
	  				$AMP_return = 0;
				} else {
					$AMP_return = 1;
				}
				break;
			
			case 'url':
				if (! preg_match('=(https?|ftp)://[a-z0-9]([a-z0-9-]*[a-z0-9])?\.[a-z0-9]=i',$AMP_field))
				{
					$AMP_return = 0;
				} else {
					$AMP_return = 1;
				}	
				break;
			
			case 'numeric':
				if(!is_numeric($AMP_field))
				{
					$AMP_return = 0;
				} else {
					$AMP_return = 1;
				}
				break;
							
			case 'alphanumeric':
				if(empty($AMP_field))
				{
					$AMP_return = 0;
				} else { 
					$AMP_return = 1; 
				}
				break;
							
			default:
				if(empty($AMP_field))
				{
					$AMP_return = 0;
				} else { 
					$AMP_return = 1; 
				}
				break;
		}
		
		return $AMP_return;
	}
}
			
				
				
			
//+----------------------------------------------------------------------------------------+
//| function : AMP_smilie_replace                                                    	   |
//| last modified: 12.01.2003                                                              |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  -- -+
//|                                                                                        |
//| replace dummy smilie code with html img tags to display smilies			   |
//| using this function will be only possible if 'string1' is filled with smiliecode       |
//| created from function AMP_smilie_add and uses the same 'string2' and 'string3'         |
//|                                                                                        |
//| string1 = String where the smiliecode exists and need to be replaced with image tags   |
//| string2 = directory where the smilies are stored                                       |
//| string3 = accessible url to smilie directory                                           |
//| integer = true or false; true will change the smilie code with images, false returns   |
//|           the string without any smilie code and without any smilie image              |
//|-------------------------------------------------------------------------------------- -|
//| AMP_smilie_replace ( string1, string2, string3, integer[0,1] )                         |
//+----------------------------------------------------------------------------------------+

if(!function_exists('AMP_smilie_replace'))
{
	function AMP_smilie_replace($AMP_string, $AMP_dir, $AMP_url, $AMP_smilie_allow)
	{
		$AMP_chdir = @chdir("$AMP_dir"); 
		if($AMP_chdir){
			$AMP_opendir=opendir('.');
	
			while (false !== ($AMP_smilies = readdir ($AMP_opendir))) {
			
				if ($AMP_smilies != "." && $AMP_smilies != "..") {
					$AMP_smiliestring = explode(".gif", $AMP_smilies);
					if($AMP_smilie_allow == '1'){  
						$AMP_string = str_replace(":$AMP_smiliestring[0]:", "<img align=\"absmiddle\" src=\"$AMP_url/$AMP_smilies\" border=\"0\">", $AMP_string);
			        	} 
			        	else 
			        	{
						$AMP_string = str_replace(":$AMP_smiliestring[0]:", "", $AMP_string);
			        	}	
				}
			
			}
			closedir($AMP_opendir); 
		} 
		else 
		{
			echo "<b><font color=\"red\">Error, could not open \"$AMP_dir\" for reading in function <i>AMP_smilie_replace</i>. process stopped!</font></b>";
			exit;
		}
		return $AMP_string;
	}
}


//+--------------------------------------------------------------------------------------+
//| function : AMP_create_smiliebar                                                 	 |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+
//|                                                                                      |
//| Read smilie direcory and build the smiliebar in ./signin.php (if set in config)	 |
//| 											 |
//+--------------------------------------------------------------------------------------+
if(!function_exists('AMP_create_smiliebar'))
{
	function AMP_create_smiliebar($AMP_dir,$AMP_uri,$AMP_callfile,$AMP_callline)
	{
	
		$AMP_chdir = @chdir("$AMP_dir"); 
		
		if($AMP_chdir){
			$AMP_opendir=opendir('.');
	
			while (false !== ($AMP_smilies = readdir ($AMP_opendir))) {
			
				settype($AMP_smiliecode,'string');
				if (preg_match("=.gif=i",$AMP_smilies)) { 
					$AMP_imagestring = explode (".gif", $AMP_smilies);
			        	$AMP_smiliecode .= " &nbsp;<a href=\"javascript:setsmile(' :$AMP_imagestring[0]: ')\"><img align=\"absmiddle\" src=\"$AMP_uri$AMP_smilies\" border=\"0\"></a>&nbsp; \n";
				}
			
			}
			closedir($AMP_opendir); 
	
		} 
		else {
			die("<b>AMP_create_smiliebar PANIC:</b> The expected directory <font color=\"red\">$AMP_dir</font> does not exist (call in <b>$AMP_callfile</b> on line <b>$AMP_callline</b>)");
				
			exit;
		}
		return $AMP_smiliecode;
	}
}


//+--------------------------------------------------------------------------------------+
//| function : AMP_setlanguage                                                	 	 |
//| last modified: 12.01.2003                                                            |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+
//|                                                                                      |
//| gets the current working language		 					 |
//| make use of user configurations in further versions                                  |
//+--------------------------------------------------------------------------------------+
if(!function_exists('AMP_setlanguage'))
{
	function AMP_setlanguage($AMP_path, $AMP_language)
	{
		global $HTTP_COOKIE_VARS;
	
		include("$AMP_path/"."$AMP_language/$AMP_language".".lang.php");
		return($_AMLlanguage);
	}
}

//+--------------------------------------------------------------------------------------+
//| function : AMP_settemplate	                                               	         |
//| last modified: 12.01.2003                                                            |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+
//|                                                                                      |
//| gets the active template			 					 |
//| make use of user configurations in further versions                                  |
//+--------------------------------------------------------------------------------------+
if(!function_exists('AMP_settemplate'))
{
	function AMP_settemplate($AMP_template)
	{
		global $HTTP_COOKIE_VARS;
	
		$AMP_template = $AMP_template;
		
		return($AMP_template);
	}
}

//+--------------------------------------------------------------------------------------+
//| function : AMP_setdate	                                                	 |
//| last modified: 12.01.2003                                                            |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+
//|                                                                                      |
//| gives all timeflags the right date to display			 		 |
//| make use of user configurations in further versions                                  |
//+--------------------------------------------------------------------------------------+
if(!function_exists('AMP_setdate'))
{
	function AMP_setdate($AMP_dateformat, $AMP_countflag, $AMP_timezone)
	{
		return @gmdate($AMP_dateformat, $AMP_countflag + (3600 * $AMP_timezone));
	}
}

//+--------------------------------------------------------------------------------------+
//| function : AMP_month_getfirstday                                          	         |
//| last modified: 25.07.2003                                                            |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+
//|                                                                                      |
//| returns the first day of a specified month                                           |
//+--------------------------------------------------------------------------------------+
if(!function_exists('AMP_month_getfirstday'))
{
	function AMP_month_getfirstday($AMP_year,$AMP_month)
	{
		settype($AMP_return,'array');
		$AMP_day = '1';
		$AMP_date = "$AMP_year-$AMP_month-$AMP_day";
		$AMP_firstday = strtotime($AMP_date);
		$AMP_return['w']  = date("w",$AMP_firstday);
		$AMP_return['W']  = date("W",$AMP_firstday);
		return($AMP_return);
	}
}

//+--------------------------------------------------------------------------------------+
//| function : AMP_month_getlastday                                          	         |
//| last modified: 25.07.2003                                                            |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+
//|                                                                                      |
//| returns the last day of a specified month                                            |
//+--------------------------------------------------------------------------------------+
if(!function_exists('AMP_month_getlastday'))
{
	function AMP_month_getlastday($AMP_year,$AMP_month)
	{
		settype($AMP_return,'array');
		$AMP_day = '1';
		$AMP_date = "$AMP_year-$AMP_month-$AMP_day";
		$AMP_firstday = strtotime($AMP_date);
		$AMP_lastday = $AMP_firstday + 2678400;
		do 
		{
			$AMP_lastday = $AMP_lastday - 86400;
		} 
		while (date("m",$AMP_lastday) != $AMP_month);
		$AMP_return['j'] = date("j",$AMP_lastday);
		$AMP_return['w'] = date("w",$AMP_lastday);
		$AMP_return['W'] = date("W",$AMP_lastday);
		
		return($AMP_return);
	}
}

//+--------------------------------------------------------------------------------------+
//| function : AMP_dayrangebyweeknr                                               	 |
//| last modified: 02.06.2003                                                            |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+
//|                                                                                      |
//| returns in $AMP_dateformat the beginning and end date form a week-number in ISO-8601 |
//+--------------------------------------------------------------------------------------+
if(!function_exists('AMP_dayrangebyweeknr'))
{
	function AMP_dayrangebyweeknr($AMP_weeknr, $AMP_year, $AMP_dateformat, $AMP_day)
	{
		$weekday = date("w",mktime(0,0,0,1,1,$AMP_year));
		$wbegin = 1;      
		if ($weekday > 4) { $wbegin = $weekday-$wbegin-1; } else { $wbegin = $wbegin-$weekday; }

		$days = ($AMP_weeknr-1)*7;
		$beginwn = mktime(0,0,0,1,1 + $wbegin + $days    ,$AMP_year);
		$endwn   = mktime(0,0,0,1,1 + $wbegin + $days +6 ,$AMP_year);

		settype($return, 'array');

		$return['start'] = date("$AMP_dateformat" , $beginwn);
		$return['end']   = date("$AMP_dateformat" , $endwn);

		$dayid = array("Mon"=>0, "Tue"=>1, "Wed"=>2, "Thu"=>3, "Fri"=>4, "Sat"=>5, "Sun"=>6);
		$day = $dayid[$AMP_day];
		
		$date = mktime(0,0,0,1,1+$wbegin+$days +$day ,$AMP_year);
		$return['day'] = date("$AMP_dateformat" , $date) ."<br>";

		return $return;
	}
}


//+----------------------------------------------------------------------------------------+
//| function : AMP_build_letterline                                                        |
//| last modified: 08.09.2003                                                              |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  -- -+
//|                                                                                        |
//| returns a letter line                                                                  |
//|                                                                                        |
//| string1 = table to select value                                                        |
//| string2 = field of table(string1) to select value                                      |
//| integer = id of the current open sql session                                           |
//|----------------------------------------------------------------------------------------|
//| AMP_check_adminlogin ( string1, string2, integer )                                     |
//+----------------------------------------------------------------------------------------+
if(!function_exists('AMT_build_letterline'))
{
	function AMT_build_letterline($AMT_numbers, $AMT_link, $AMT_tbl, $AMT_field, $AMT_sqlid)
	{
		settype($AMT_return,'string');
		if($AMT_numbers == 1)
		{
			$a = array('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F','G','H','I','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z');
		}
		else
		{
			$a = array('A','B','C','D','E','F','G','H','I','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z');
		}
		foreach ($a as $v) 
		{	
			$AMT_return .= "<a href=\"".$AMT_link."".$v."\">".$v."</a>";
		}
	}
}

//+----------------------------------------------------------------------------------------+
//| function : AMP_usercheck_admin                                                         |
//| last modified: 12.01.2003                                                              |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  -- -+
//|                                                                                        |
//| this function will proof the user                                                      |
//| If he logged in as a admin, AMP_usercheck_admin returns true                           |
//|                                                                                        |
//| string1 = name of the cookie                                                           |
//| string2 = table of user where session are stored                                       |
//| integer = id of the current open sql session                                           |
//|----------------------------------------------------------------------------------------|
//| AMP_check_adminlogin ( string1, string2, integer )                                     |
//+----------------------------------------------------------------------------------------+
if(!function_exists('AMP_usercheck_admin'))
{
	function AMP_usercheck_admin($AMP_cookiename, $AMP_tablename, $AMP_sqlconnect)
	{
		global $HTTP_COOKIE_VARS;
		
		if(isset($HTTP_COOKIE_VARS[$AMP_cookiename]))
		{
			$AMP_result = AMS_sql_fetch_array(AMS_sql_query("SELECT * FROM ".$AMP_tablename." WHERE user_session = '".$HTTP_COOKIE_VARS["$AMP_cookiename"]."' AND user_status = '1'", $AMP_sqlconnect), $AMP_sqlconnect);
		}
		else
		{
			$AMP_result = false;
		}
		return $AMP_result;
		//return true;
	
	}
}
//+----------------------------------------------------------------------------------------+
//| function : AMP_usercheck_validuser                                                	   |
//| last modified: 27.01.2003                                                              |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  -- -+
//|                                                                                        |
//| this function will proof the user who want's to connect                                |
//| If the user logged in already, AMP_usercheck_validuser returns true                    |
//|                                                                                        |
//| string1 = name of the cookie                                                           |
//| string2 = table of user where session are stored                                       |
//| integer = id of the current open sql session                                           |
//|----------------------------------------------------------------------------------------|
//| AMP_check_userlogin ( string1, string2, integer )                                      |
//+----------------------------------------------------------------------------------------+
if(!function_exists('AMP_usercheck_validuser'))
{
	function AMP_usercheck_validuser($AMP_cookiename, $AMP_tablename, $AMP_sqlconnect)
	{
	
		global $HTTP_COOKIE_VARS;
	
		if(isset($HTTP_COOKIE_VARS[$AMP_cookiename]))
		{
			$AMP_cookieuid = $HTTP_COOKIE_VARS[$AMP_cookiename];
			$AMP_query  = AMS_sql_query("SELECT * FROM ".$AMP_tablename." WHERE user_session = '".$AMP_cookiename."' AND user_status = '2'", $AMP_sqlconnect);
			$AMP_result = AMS_sql_fetch_array($AMP_query, $AMP_sqlconnect);
		}
		else
		{
			$AMP_result = false;
		}
		return $AMP_result;
	
	}
}


//+--------------------------------------------------------------------------------------+
//| function : AMG_build_bodyformat                                                      |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+
//|                                                                                      |
//| This function modify the output as follows:						 |
//| 											 |
//| deaktivate html (if set config)							 |
//| returns, breaks will be chanched to html <br>					 |
//| User written urls will be recognized and hand out as links (if set in config)        |
//| read the smilie directory and gegerate output to replace :image with <img>           |
//| "wicked" code will be defused							 |
//|											 |
//+--------------------------------------------------------------------------------------+
if(!function_exists('AMP_build_bodyformat'))
{
	function AMP_build_bodyformat($AMP_new, $AMP_allow_html)
	{
	
		global $_AMGusrcfg, $_AMGconfig;
	
		
		if($AMP_allow_html == '0'){
			$AMP_new = strip_tags($AMP_new);
		}
	
	
		$AMP_pattern = '#(^|[^\"=]{1})(http://|ftp://|mailto:|news:)([^\s<>]+)([\s\n<>]|$)#sm';
		if(preg_match("/^.jpg|.jpg$/", $AMP_pattern) || 
		   preg_match("/^.gif|.gif$/", $AMP_pattern) ||
		   preg_match("/^.png|.png$/", $AMP_pattern) ||
		   preg_match("/^.tif|.tif$/", $AMP_pattern) ||
		   preg_match("/^.bmp|.bmp$/", $AMP_pattern))
		{
			$AMP_new = preg_replace($AMG_pattern,"<a href=\"\\2\\3\" target=\"_blank\">\\2\\3</a>\\4",$AMP_new);
		}
		$AMP_new = str_replace("\'", "'", $AMP_new);
		$AMP_new = str_replace("\r\n", "<br>", $AMP_new);
		$AMP_new= nl2br($AMP_new);
	
		return $AMP_new;
	}
}

//+--------------------------------------------------------------------------------------+
//| function : AMP_create_link	                                                 	 |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+
//|                                                                                      |
//| stand alone link creation. Also included in AMP_build_bodyformat			 |
//| 											 |
//+--------------------------------------------------------------------------------------+
if(!function_exists('AMP_create_link'))
{
	function AMP_create_link($AMG_new)
	{
		$AMG_pattern = '#(^|[^\"=]{1})(http://|ftp://|mailto:|news:)([^\s<>]+)([\s\n<>]|$)#sm';
		$AMG_new = preg_replace($AMG_pattern,"<a href=\"\\2\\3\" target=\"_blank\">\\2\\3</a>\\4",$AMG_new);
		
		return $AMG_new;
	}
}

//+--------------------------------------------------------------------------------------+
//| function : AMP_check_email                                                           |
//+--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --+
//|                                                                                      |
//| AMP_check_email examine the e-mail syntax                                            | 
//|											 |
//+--------------------------------------------------------------------------------------+
if(!function_exists('AMP_check_email'))
{
	function AMP_check_email($AMP_email)
	{
		if (!eregi("^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,4}$",$AMP_email)) {
	  		return false;
		} else {
			return true;
		}
	}
}

if(!function_exists('AMP_badwordfilter'))
{
	function AMP_badwordfilter($AMP_badwordtable, $AMP_badwordcell, $AMP_replacementcell, $AMP_connectid, $AMP_string)
	{
		
		$AMP_wrdfil_query = AMS_sql_query("SELECT * FROM ".$AMP_badwordtable."", $AMP_connectid);
		while($AMP_wrdfil_array = AMS_sql_fetch_array($AMP_wrdfil_query , $AMP_connectid))
		{
			$AMP_string = str_replace($AMP_wrdfil_array[$AMP_badwordcell], $AMP_wrdfil_array[$AMP_replacementcell], $AMP_string);
		}		
		return $AMP_string;
	}
}
?>